// outputs webpack stats to console if there are no errors or warnings

"use strict";

function error(error) {
	// BELLs when something goes wrong!
	console.log("\u0007" + error);
}

function warning(warning) {
	console.log(warning);
}

module.exports = function notify_stats(stats) {
	var json = stats.toJson();

	// if there were any errors
	if (json.errors.not_empty()) {
		json.errors.forEach(error);
	}
	// if there were any warnings
	else if (json.warnings.not_empty()) {
		json.warnings.forEach(warning);
	}
	// if it's ok
	else {
		console.log(stats.toString({
			chunks: false,
			colors: true
		}));
	}
};
//# sourceMappingURL=notify stats.js.map