// ideally client shouldn't know the "webpack" word,
// but currently there's no other way found to "require()" an image on the server.
//
// (maybe the right solution would be to just require() all images
//  both on the client and the server (without differentiating between them)
//  and instrument all server require calls like coffeescript does
//  with require("coffeescript/register")?
//  read the article for more info on Node.js require hooks:
//  http://bahmutov.calepin.co/hooking-into-node-loader-for-fun-and-profit.html)

'use strict';

var _interopRequireDefault = require('babel-runtime/helpers/interop-require-default')['default'];

Object.defineProperty(exports, '__esModule', {
	value: true
});
exports.stats = stats;
exports.require_server_image = require_server_image;

var _webpackWebpackConfigJs = require('../../webpack/webpack.config.js');

var _webpackWebpackConfigJs2 = _interopRequireDefault(_webpackWebpackConfigJs);

var webpack_stats = undefined;

function stats() {
	if (_client_) {
		throw new Error('Must not be called on client');
	}

	if (_development_ || !exists(webpack_stats)) {
		// Do not cache webpack stats: the script file would change since
		// hot module replacement is enabled in the development env
		webpack_stats = load(_webpackWebpackConfigJs2['default'].webpack_stats_path);
	}

	return webpack_stats;
}

function require_server_image(path) {
	if (!path) {
		return '';
	}

	if (_client_) {
		throw new Error('server-side only image resolver called on client');
	}

	var images = stats().images;
	if (!images) {
		return '';
	}

	// Find the correct image
	var regexp = new RegExp(path + '$');
	var image = images.find(function (image) {
		return regexp.test(image.original);
	});

	// Serve image
	if (image) {
		return image.compiled;
	}

	// Serve a not-found asset maybe?
	return '';
}
//# sourceMappingURL=webpack.js.map